// Code generated by go-swagger; DO NOT EDIT.

package builds

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewBuildTriggerParams creates a new BuildTriggerParams object
// with the default values initialized.
func NewBuildTriggerParams() *BuildTriggerParams {
	var ()
	return &BuildTriggerParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewBuildTriggerParamsWithTimeout creates a new BuildTriggerParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewBuildTriggerParamsWithTimeout(timeout time.Duration) *BuildTriggerParams {
	var ()
	return &BuildTriggerParams{

		timeout: timeout,
	}
}

// NewBuildTriggerParamsWithContext creates a new BuildTriggerParams object
// with the default values initialized, and the ability to set a context for a request
func NewBuildTriggerParamsWithContext(ctx context.Context) *BuildTriggerParams {
	var ()
	return &BuildTriggerParams{

		Context: ctx,
	}
}

// NewBuildTriggerParamsWithHTTPClient creates a new BuildTriggerParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewBuildTriggerParamsWithHTTPClient(client *http.Client) *BuildTriggerParams {
	var ()
	return &BuildTriggerParams{
		HTTPClient: client,
	}
}

/*BuildTriggerParams contains all the parameters to send to the API endpoint
for the build trigger operation typically these are written to a http.Request
*/
type BuildTriggerParams struct {

	/*AppSlug
	  App slug

	*/
	AppSlug string
	/*BuildParams
	  Build trigger parameters

	*/
	BuildParams *models.V0BuildTriggerParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the build trigger params
func (o *BuildTriggerParams) WithTimeout(timeout time.Duration) *BuildTriggerParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the build trigger params
func (o *BuildTriggerParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the build trigger params
func (o *BuildTriggerParams) WithContext(ctx context.Context) *BuildTriggerParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the build trigger params
func (o *BuildTriggerParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the build trigger params
func (o *BuildTriggerParams) WithHTTPClient(client *http.Client) *BuildTriggerParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the build trigger params
func (o *BuildTriggerParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppSlug adds the appSlug to the build trigger params
func (o *BuildTriggerParams) WithAppSlug(appSlug string) *BuildTriggerParams {
	o.SetAppSlug(appSlug)
	return o
}

// SetAppSlug adds the appSlug to the build trigger params
func (o *BuildTriggerParams) SetAppSlug(appSlug string) {
	o.AppSlug = appSlug
}

// WithBuildParams adds the buildParams to the build trigger params
func (o *BuildTriggerParams) WithBuildParams(buildParams *models.V0BuildTriggerParams) *BuildTriggerParams {
	o.SetBuildParams(buildParams)
	return o
}

// SetBuildParams adds the buildParams to the build trigger params
func (o *BuildTriggerParams) SetBuildParams(buildParams *models.V0BuildTriggerParams) {
	o.BuildParams = buildParams
}

// WriteToRequest writes these params to a swagger request
func (o *BuildTriggerParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app-slug
	if err := r.SetPathParam("app-slug", o.AppSlug); err != nil {
		return err
	}

	if o.BuildParams != nil {
		if err := r.SetBodyParam(o.BuildParams); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
